<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="巡查人员" prop="userId">
        <el-select v-model="queryParams.userId" placeholder="请选择巡查人员" clearable size="small">
          <el-option
            v-for="item in workerList"
            :key="item.id"
            :label="item.name"
            :value="item.id"/>
        </el-select>
      </el-form-item>
      <el-form-item label="警示桩名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入警示桩名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['gas:warningPile:add']"
        >新增
        </el-button>
      </el-col>
<!--      <el-col :span="1.5">-->
<!--        <el-button-->
<!--          type="success"-->
<!--          plain-->
<!--          icon="el-icon-edit"-->
<!--          size="mini"-->
<!--          :disabled="single"-->
<!--          @click="handleUpdate"-->
<!--          v-hasPermi="['gas:warningPile:edit']"-->
<!--        >修改-->
<!--        </el-button>-->
<!--      </el-col>-->
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['gas:warningPile:remove']"
        >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['gas:warningPile:export']"
        >导出
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="warningPileList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="主键id" align="center" prop="id" v-if="false"/>
      <el-table-column label="序号" width="70">
        <template slot-scope="scope">
          {{(queryParams.pageNum-1)*queryParams.pageSize+scope.$index+1}}
        </template>
      </el-table-column>
      <el-table-column label="巡查人员" align="center" prop="userName">
<!--        <template slot-scope="scope">-->
<!--          {{ getUserName(scope.row.userId) }}-->
<!--        </template>-->
      </el-table-column>
      <el-table-column label="警示桩名称" align="center" prop="name"/>
      <el-table-column label="警示桩信信息" align="center" prop="warningPileInfo"/>
      <el-table-column label="经度" align="center" prop="longitude"/>
      <el-table-column label="纬度" align="center" prop="latitude"/>
      <el-table-column label="创建人" align="center" prop="createByName"/>
      <el-table-column label="创建时间" align="center" prop="createTime"/>
      <el-table-column label="照片" align="center" >
        <template slot-scope="scope">
          <el-image
            style="width: 50px; height: 50px"
            :src="scope.row.photoList!=null?scope.row.photoList[0]:''"
            :preview-src-list="scope.row.photoList">
          </el-image>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-view"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['gas:warningPile:edit']"
          >查看
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['gas:warningPile:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改警示桩对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px" :disabled="disabled">
        <el-form-item label="巡查人员" prop="userId">
          <el-select v-model="form.userId" placeholder="请选择巡查人员" filterable multiple style="width: 100%">
            <el-option
              v-for="item in workerList"
              :key="item.id"
              :label="item.name"
              :value="item.id"/>
          </el-select>
        </el-form-item>
        <el-form-item label="警示桩名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入警示桩名称"/>
        </el-form-item>
        <el-form-item label="警示桩信息" prop="warningPileInfo">
          <el-input v-model="form.warningPileInfo" type="textarea" placeholder="请输入内容"/>
        </el-form-item>
        <el-form-item label="经度" prop="longitude">
          <el-input v-model="form.longitude" placeholder="请输入经度"/>
        </el-form-item>
        <el-form-item label="纬度" prop="latitude">
          <el-input v-model="form.latitude" placeholder="请输入纬度"/>
        </el-form-item>
        <el-form-item label="照片" prop="photoList">
          <imageUpload v-model="form.photoList" :disabled="disabled"/>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" type="textarea" placeholder="请输入内容"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button :loading="buttonLoading" type="primary" v-if="!disabled" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">{{ disabled ? "关 闭" : "取 消" }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listWarningPile,
  getWarningPile,
  delWarningPile,
  addWarningPile,
  updateWarningPile
} from "@/api/gas/warningPile";
import {getWorker} from "@/api/gas/user";

export default {
  name: "WarningPile",
  data() {
    return {
      // 按钮loading
      buttonLoading: false,
      // 遮罩层
      loading: true,
      disabled: false,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 警示桩表格数据
      warningPileList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userId: undefined,
        name: undefined,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        userId: [
          {required: true, message: "巡查人员不能为空", trigger: "change"}
        ],
        name: [
          {required: true, message: "警示桩名称不能为空", trigger: "blur"}
        ],
        warningPileInfo: [
          {required: true, message: "警示桩信信息不能为空", trigger: "blur"}
        ],
        longitude: [
          {required: false, message: "经度不能为空", trigger: "blur"}
        ],
        latitude: [
          {required: false, message: "纬度不能为空", trigger: "blur"}
        ],
        remarks: [
          {required: false, message: "备注不能为空", trigger: "blur"}
        ],
      },
      workerList: []
    };
  },
  created() {
    this.getWorker();
    this.getList();
  },
  methods: {
    getUserName(userId) {
      let name = ''
      for (let i = 0; i < userId.split(",").length; i++) {
        if (i === 0) name = this.workerList.filter(item => item.id == userId.split(",")[i])[0].name
        else name = name + "," + this.workerList.filter(item => item.id == userId.split(",")[i])[0].name
      }
      return name
    },
    getWorker() {
      getWorker().then(req => this.workerList = req.data)
    },
    /** 查询警示桩列表 */
    getList() {
      this.loading = true;
      listWarningPile(this.queryParams).then(response => {
        this.warningPileList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: undefined,
        userId: undefined,
        name: undefined,
        warningPileInfo: undefined,
        longitude: undefined,
        latitude: undefined,
        remarks: undefined,
        photoList: '',
        delFlag: undefined,
        createBy: undefined,
        createTime: undefined,
        updateBy: undefined,
        updateTime: undefined
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.disabled = false;
      this.title = "添加警示桩";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.loading = true;
      this.disabled = true;
      this.reset();
      const id = row.id || this.ids
      getWarningPile(id).then(response => {
        this.loading = false;
        this.form = response.data;
        this.form.userId = response.data.userId.split(",").map(Number);
        this.open = true;
        this.title = "修改警示桩";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.buttonLoading = true;
          if (this.form.id != null) {
            if (typeof this.form.photoList === 'string') {
              this.form.photoList = this.form.photoList.split(',')
            }
            this.form.userId = this.form.userId.join()
            updateWarningPile(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          } else {
            this.form.userId = this.form.userId.join()
            this.form.photoList = this.form.photoList.split(',')
            addWarningPile(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除警示桩编号为"' + ids + '"的数据项？').then(() => {
        this.loading = true;
        return delWarningPile(ids);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).finally(() => {
        this.loading = false;
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.$download.excel('/gas/warningPile/export', this.queryParams);
    }
  }
};
</script>
